#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTreeWidget>
#include <QPushButton>
#include <QSpinBox>

namespace Ui {
class MainWindow;
}

class Factory : public QTreeWidgetItem
{
public:
    virtual QWidget * create () { return NULL; };
};

class ButtonFactory : public Factory
{
public:
    QWidget * create () { return new QPushButton; }
    ButtonFactory () { setText (0, "Button"); }
};

class EditFactory : public Factory
{
public:
    QWidget * create () { return new QSpinBox; }
    EditFactory () { setText (0, "Spin Box"); }
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void focusChanged (QWidget * old, QWidget * now);
    void on_toolbox_itemPressed (QTreeWidgetItem * item, int column);

private:
    Ui::MainWindow *ui;
//    Area * area;
};



#endif // MAINWINDOW_H
